=== asmparsertest/CMakeLists.txt ===
piglit_include_target_api()
