=== spec/arb_draw_instanced/CMakeLists.txt ===
add_subdirectory (execution)
