=== spec/arb_gpu_shader5/CMakeLists.txt ===
add_subdirectory (compiler)
add_subdirectory (execution)
add_subdirectory (linker)
piglit_include_target_api()
