=== spec/arb_gpu_shader_fp64/CMakeLists.txt ===
add_subdirectory (execution)
add_subdirectory (shader_storage)
piglit_include_target_api()
