=== spec/glsl-1.30/CMakeLists.txt ===
add_subdirectory (linker)
add_subdirectory (execution)
piglit_include_target_api()
