=== spec/arb_geometry_shader4/execution/CMakeLists.txt ===
add_subdirectory (program-parameter)
piglit_include_target_api()
