## piglit 0~git20200212-f4710c51b

=== debian/changelog ===
piglit (0~git20200212-f4710c51b-1) unstable; urgency=medium

  * Update piglit upstream version to f4710c51b (Closes: #933275,
    #948284)
  * d/gbp.conf: Fix gbp config file duplicate entry
  * d/control: Recommend waffle-utils (Closes: #943799)
  * d/control: Depend on bash-completion (Closes: #943802)
  * d/rules: Remove gcc-7 workaround (Closes: #922498)
  * d/changelog: Note that #933275 was fixed by piglit upgrade
  * d/changelog: Note that #948284 was fixed by piglit upgrade
  * d/control: Update Standards-Version to 4.4.1
  * debian: Update to debhelper-compat 12
  * d/copyright: Remove two deleted files
  * d/control: Update Standards-Version to 4.5.0
  * d/rules: Fix lintian package-contains-empty-directory
  * d/patches: Fix bash completion install and lintian warning

 -- Jordan Justen <jordan.l.justen@intel.com>  Fri, 21 Feb 2020 21:20:04 -0800
